#pragma comment(lib, "aygshell.lib")

#include <windows.h>
#include <tchar.h>
#pragma warning(disable:4819)	// regext.h
#include <regext.h>
#pragma warning(default:4819)

#include "Collection.h"
#include "BG.h"

////////////////////////////////////////////////////////////////////////
// WXg
//

// HKEY_CURRENT_USER
#define SHPHONELIB_REG_KEY     _T("Software\\Sharp\\ShPhoneLib")
#define RFSTRENGTH_REG_KEY     _T("RFStrength")
#define PPPCONNECT_REG_KEY     _T("PppConnect")

// HKEY_LOCAL_MACHINE
#define HARDWARE_REG_KEY       _T("System\\State\\Hardware")
#define CRADLE_REG_KEY	       _T("Cradled")
#define WIFI_REG_KEY	       _T("Wifi")
#define ACTIVESYNC_REG_KEY     _T("System\\State\\ActiveSync")
#define SYNCHRO_REG_KEY	       _T("Synchronizing")

#define CONNECT_REG_KEY	       _T("System\\State\\Connections")
#define DESKTOP_REG_KEY	       _T("System\\State\\Connections\\Desktop")
#define MODEM_REG_KEY	       _T("System\\State\\Connections\\Modem")
#define NETWORK_REG_KEY	       _T("System\\State\\Connections\\NetWork")
#define COUNT_REG_KEY	       _T("Count")

#define STORAGE_REG_KEY	       _T("System\\StorageManager\\Profiles\\SDMemory")
#define FOLDER_REG_KEY	       _T("Folder")

#define APP_REGISTRY	       _T("Software\\DevStatusBar")
#define INVERT_REG_KEY	       _T("InvartMemoryValue")

//----------------------------------------------------------------------
// o[OtNX
//
BOOL Bg::Draw(HDC hdc)
{
  HGDIOBJ hPen, hBrush;	// X̃IuWFNgۑ
  int nReso = pDC->GetResolution();

  if (pInfo == NULL) return FALSE;
  hPen	 = SelectObject(hdc, CreatePen(PS_SOLID, 1, pInfo->cFrameColor));
  hBrush = SelectObject(hdc, CreateSolidBrush(pInfo->cBrushColor));
  if (nValue>=nReso) {
    Rectangle(hdc, nLeft, 0, nRight, nHeight);
  } else {
    int nPos = nLeft + ((nWidth * nValue) / nReso);

    Rectangle(hdc, nLeft, 0, nPos,   nHeight);
    DeleteObject(SelectObject(hdc, CreateSolidBrush(pInfo->cBlankColor)));
    Rectangle(hdc, nPos,  0, nRight, nHeight);
  }
  DeleteObject(SelectObject(hdc, hBrush));	// IuWFNgɖ߂
  DeleteObject(SelectObject(hdc, hPen));
  return TRUE;
}

const BgEntry * const Bg::pEntryTbl[] = {
  &BgRF::pEntry,      &BgNetMode::pEntry,     &BgBattery::pEntry,
  &BgMemory::pEntry,  &BgCPU::pEntry,         &BgStorage::pEntry,
  &BgTraffic::pEntry, &BgShiftStatus::pEntry,
  NULL,
};

BOOL Bg::CheckOption(TCHAR tcOption)
{
  const BgEntry *const *pBGE = pEntryTbl;

  while (*pBGE!=NULL) {
    if (_tcschr((*pBGE)->lpOptions, tcOption)!=NULL) return TRUE;
    pBGE++;
  }
  return FALSE;
}

Bg *Bg::Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting)
{
  const BgEntry *const *pBGE = pEntryTbl;

  while (*pBGE!=NULL) {
    if (_tcschr((*pBGE)->lpOptions, pSetting.tcOption) != NULL)
      return ((*pBGE)->fCreate)(hWnd, nUnique, pSetting);
    pBGE++;
  }
  return FALSE;
}

//----------------------------------------------------------------------
// ʐMx
//
const BgEntry   BgRF::pEntry =
  {_T("r"), {RFSTRENGTH_WIDTH,}, {MIN_FIXWIDTH,}, 
   (Bg *(__cdecl *const )(HWND,UINT,const BgSetting &)) &BgRF::Create,};
const RegInfo   BgRF::sRegInfo =
  {0, {HKEY_CURRENT_USER,  SHPHONELIB_REG_KEY, RFSTRENGTH_REG_KEY,}, 0x00,};
const DrawTable BgRF::pInfoTbl[] = {
  {0, RGB(0x44,0x44,0x44), RGB(0x00,0x00,0x00), RGB(0x00,0x00,0x00),},
  {0, RGB(0xcc,0x00,0x00), RGB(0xff,0x44,0x44), RGB(0x00,0x00,0x00),},
  {1, RGB(0xcc,0x00,0x00), RGB(0xff,0x44,0x44), RGB(0x00,0x00,0x00),},
  {2, RGB(0xad,0x44,0x22), RGB(0xff,0x88,0x44), RGB(0x00,0x00,0x00),},
  {3, RGB(0xad,0x44,0x22), RGB(0xff,0x88,0x44), RGB(0x00,0x00,0x00),},
  {4, RGB(0x44,0xff,0x44), RGB(0x00,0xff,0x00), RGB(0x00,0x00,0x00),},
  {5, RGB(0x44,0xff,0x44), RGB(0x00,0xff,0x00), RGB(0x00,0x00,0x00),},
};

BgRF::BgRF(HWND hWnd, UINT nUnique, const BgSetting &pSetting, DWORD dwData) :
  Bg(nUnique, pSetting.nHeight)
{
  SetFixWidth(GetParameter(pEntry, pSetting, 0));
  bVariWidth = pSetting.bCaps;
  pDC = new DCDummy(5);
  nStrength = 0;
  hNotify = NULL;
  RegistryNotifyWindow(sRegInfo.sRegistry.hKey,
		       sRegInfo.sRegistry.pszSubkey, 
		       sRegInfo.sRegistry.pszName,
		       hWnd, GetUserMessageID(),
		       sRegInfo.lUserData,
		       NULL, &hNotify);
  MessageHandler(hWnd, GetUserMessageID(), dwData, sRegInfo.lUserData);
}
BgRF::~BgRF()
{
  if (hNotify!=NULL) RegistryCloseNotification(hNotify);
  delete pDC;
}
BgRF *BgRF::Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting)
{
  DWORD dwData;

  // WXg݂̑`FbN
  if (FAILED(RegistryGetDWORD(sRegInfo.sRegistry.hKey,
			      sRegInfo.sRegistry.pszSubkey, 
			      sRegInfo.sRegistry.pszName,
			      &dwData)))
    return NULL;
  return new BgRF(hWnd, nUnique, pSetting, dwData);
}
BOOL BgRF::MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  if (wParam<=6) nStrength = wParam;
  pInfo  = &pInfoTbl[nStrength].cInfo;
  nValue = (bVariWidth)?(pInfoTbl[nStrength].cIndex):5;
  return TRUE;
}
//----------------------------------------------------------------------
// ʐM[h
//
const BgEntry BgNetMode::pEntry =
  {_T("n"), 
   {NETWORKMODE_WIDTH, ANI_UPDATE,    NET_MEASUREPERIOD,},
   {MIN_FIXWIDTH,      BAR_MINUPDATE, BAR_MINUPDATE,},
   (Bg *(__cdecl *const )(HWND,UINT,const BgSetting &)) &BgNetMode::Create,};
const RegInfo BgNetMode::sRegInfoTbl[] = {
  // connected
  { 3, {HKEY_LOCAL_MACHINE, MODEM_REG_KEY,      COUNT_REG_KEY,},      0x00,},
  { 2, {HKEY_LOCAL_MACHINE, NETWORK_REG_KEY,    COUNT_REG_KEY,},      0x00,},
  { 1, {HKEY_LOCAL_MACHINE, HARDWARE_REG_KEY,   CRADLE_REG_KEY,},     0x00,},
  // connecting
  {-3, {HKEY_CURRENT_USER,  SHPHONELIB_REG_KEY, PPPCONNECT_REG_KEY,}, 0x00,},
  {-2, {HKEY_LOCAL_MACHINE, HARDWARE_REG_KEY,   WIFI_REG_KEY,},	      0x08,},
  {-1, {HKEY_LOCAL_MACHINE, ACTIVESYNC_REG_KEY, SYNCHRO_REG_KEY,},    0x00,},
};
static const ColorInfo NETWORKMODE_STATUS_OFFLINE = 
  {RGB(0x88, 0x88, 0x88), RGB(0x00, 0x00, 0x00), RGB(0x00, 0x00, 0x00),};
static const ColorInfo NETWORKMODE_STATUS_PHS = 
  {RGB(0x88, 0x88, 0x88), RGB(0xff, 0xff, 0xff), RGB(0x00, 0x00, 0x00),};
static const ColorInfo NETWORKMODE_STATUS_NETWORK = 
  {RGB(0x00, 0x88, 0x00), RGB(0x00, 0xff, 0x00), RGB(0x00, 0x00, 0x00),};
static const ColorInfo NETWORKMODE_STATUS_ACTIVESYNC = 
  {RGB(0x88, 0x88, 0x00), RGB(0xff, 0xff, 0x00), RGB(0x00, 0x00, 0x00),};
const ColorInfo * BgNetMode::sModeTbl[] = {
  &NETWORKMODE_STATUS_OFFLINE,	  // 000
  &NETWORKMODE_STATUS_ACTIVESYNC, // 001
  &NETWORKMODE_STATUS_NETWORK,	  // 010	
  &NETWORKMODE_STATUS_NETWORK,	  // 011	
  &NETWORKMODE_STATUS_PHS,	  // 100
  &NETWORKMODE_STATUS_PHS,	  // 101
  &NETWORKMODE_STATUS_PHS,	  // 110
  &NETWORKMODE_STATUS_PHS,	  // 111
};

BgNetMode::BgNetMode(HWND hWnd, UINT nUnique, const BgSetting &pSetting) : 
  Bg(nUnique, pSetting.nHeight)
{
  DWORD dwData;
  NOTIFICATIONCONDITION nc;

  SetFixWidth(GetParameter(pEntry, pSetting, 0));
  nAnimate = GetParameter(pEntry, pSetting, 1);
  bMonitor = pSetting.bCaps;
  if (bMonitor) {
    pDC = DCTraffic::GetInstance(BARRESO, GetParameter(pEntry, pSetting, 2));
    pDC->SetMessage(FALSE, hWnd, GetUserMessageID());
    hWndSaved = hWnd;
  } else {
    pDC = new DCDummy(BARRESO);
  }

  // WXglĎ
  nc.ctComparisonType = REG_CT_ANYCHANGE;
  nc.TargetValue.dw   = 0xFFFFFFFFUL;
  // f[^̎擾 / WXgĎo^
  nMode = 0;
  for (int i=0; i<NMWATCHREGNUM; i++) {
    nc.dwMask = sRegInfoTbl[i].dwMask;
    RegistryNotifyWindow(sRegInfoTbl[i].sRegistry.hKey,
			 sRegInfoTbl[i].sRegistry.pszSubkey, 
			 sRegInfoTbl[i].sRegistry.pszName,
			 hWnd, GetUserMessageID(),
			 sRegInfoTbl[i].lUserData,
			 sRegInfoTbl[i].dwMask?&nc:NULL,
			 &hNotify[i]);
    if (FAILED(RegistryGetDWORD(sRegInfoTbl[i].sRegistry.hKey,
				sRegInfoTbl[i].sRegistry.pszSubkey, 
				sRegInfoTbl[i].sRegistry.pszName,
				&dwData))) {
      dwData = 0;
    }
    nCnt = 0;
    if (sRegInfoTbl[i].lUserData>=0) {
      MessageHandler(hWnd, GetUserMessageID(),dwData,sRegInfoTbl[i].lUserData);
    }
  }
}
BgNetMode::~BgNetMode()
{
  for (int i=0; i<NMWATCHREGNUM; i++)
    if (hNotify[i]!=NULL) RegistryCloseNotification(hNotify[i]);
  if (bMonitor) {
    pDC->DelMessage(hWndSaved, GetUserMessageID());
    DCTraffic::ReleaseInstance(&pDC);
  } else {
    delete pDC;
  }
}
BgNetMode *BgNetMode::Create(HWND hWnd,UINT nUnique,const BgSetting &pSetting)
{
  return new BgNetMode(hWnd, nUnique, pSetting);
}
BOOL BgNetMode::MessageHandler(HWND hWnd, 
			       UINT msg, WPARAM wParam, LPARAM lParam)
{ 
  int nReso = pDC->GetResolution();

  if (msg==WM_TIMER) {
      // gtBbN̍XV
    if (bDispMode) {
      // ڑAj[V\
      nValue = (nValue+(nReso/20))%nReso;
    } else {
      if (nCnt != 0) {
	// _ŕ\
	nCnt--;
	nValue = nValue?0:nReso;
      } else {
 	// _ŏI
	KillTimer(hWnd, GetUserTimerID());
	nValue = nReso;
      }
    }
  } else {
    if (lParam==0) {		// lParam == 0 /gtBbNɂ_ŕ\Jn
      if (nCnt == 0) {
	bDispMode = FALSE;
	SetTimer(hWnd, GetUserTimerID(), nAnimate, NULL);
      }
      nCnt = pDC->GetPeriod() / nAnimate + 1;
      return FALSE;
    } else if (lParam>0) {	// lParam > 0 / ڑԕύX
      if (wParam) {	// ڑ
	nMode |=  (1<<(lParam-1));
      } else {		// ؒf
	nMode &= ~(1<<(lParam-1));
      }
    } else {			// lParam < 0 / ڑ
      if (wParam) {	// ڑ
	if (~(0xFFFFFFFFU<<(-lParam)) > nMode) {
	  // ڑAj[VJn
	  nValue    = 0;
	  pInfo     = sModeTbl[nMode|(1<<(-lParam-1))];
	  bDispMode = TRUE;
	  SetTimer(hWnd, GetUserTimerID(), nAnimate, NULL);
	  return TRUE;
	} else {
	  // ""Őڑ͉Ȃ
	  return FALSE;
	}
      }
    }
    // Aj[VI
    nValue    = nReso;
    pInfo     = sModeTbl[nMode];
    KillTimer(hWnd, GetUserTimerID());
  }
  return TRUE;
}
//----------------------------------------------------------------------
// obe
//
const BgEntry   BgBattery::pEntry =
  {_T("b"), {BAR_UPDATE,},{BAR_MINUPDATE,},
  (Bg *(__cdecl *const )(HWND,UINT,const BgSetting &)) &BgBattery::Create,};
const DrawTable BgBattery::pInfoTbl[] = {
#ifndef USE_BATTERYFLAG
  // Charging
  {100, {RGB(0xff,0x88,0x44), RGB(0xff,0x88,0x00), RGB(0x00,0x00,0x00),},},// O
  // >=50
  {49,	{RGB(0x44,0xcc,0x44), RGB(0x00,0xcc,0x00), RGB(0x00,0x00,0x00),},},// G
  // >=10
  {9,	{RGB(0x88,0x88,0x44), RGB(0xff,0xf2,0x00), RGB(0x00,0x00,0x00),},},// Y
  // >=1
  {0,	{RGB(0xcc,0x00,0x00), RGB(0xff,0x44,0x44), RGB(0x00,0x00,0x00),},},// R
  {-1,	{RGB(0x88,0x88,0x88), RGB(0x00,0x00,0x00), RGB(0x00,0x00,0x00),},},
#else
  {BATTERY_FLAG_CHARGING,
   {RGB(0xff,0x88,0x44), RGB(0xff,0x88,0x00), RGB(0x00,0x00,0x00),},},
  {BATTERY_FLAG_HIGH,
   {RGB(0x44,0xcc,0x44), RGB(0x00,0xcc,0x00), RGB(0x00,0x00,0x00),},},
  {BATTERY_FLAG_LOW,
   {RGB(0x88,0x88,0x44), RGB(0xff,0xff,0x00), RGB(0x00,0x00,0x00),},},
  {BATTERY_FLAG_CRITICAL,
   {RGB(0x88,0x44,0x44), RGB(0x88,0x00,0x00), RGB(0x00,0x00,0x00),},},
  {BATTERY_FLAG_NO_BATTERY,
   {RGB(0x88,0x44,0x44), RGB(0x88,0x00,0x00), RGB(0x00,0x00,0x00),},},
  {BATTERY_FLAG_UNKNOWN,
   {RGB(0x88,0x88,0x88), RGB(0x00,0x00,0x00), RGB(0x00,0x00,0x00),},},
#endif
};

BgBattery::BgBattery(HWND hWnd, UINT nUnique, const BgSetting &pSetting) :
  Bg(nUnique, pSetting.nHeight)
{
  SetFixWidth(0);
  pDC = new DCBattery(100,GetParameter(pEntry,pSetting, 0));
  pDC->SetMessage(TRUE, hWnd, GetUserMessageID());
  pDC->Start();
}
BgBattery *BgBattery::Create(HWND hWnd,UINT nUnique,const BgSetting &pSetting)
{
  return new BgBattery(hWnd, nUnique, pSetting);
}
BOOL BgBattery::MessageHandler(HWND hWnd, 
			       UINT msg, WPARAM wParam, LPARAM lParam)
{
  const	DrawTable *p = pInfoTbl;
  DCBattery *pDCB = static_cast<DCBattery *> (pDC);

  nValue = lParam;
#ifndef USE_BATTERYFLAG
  // ߂lI(/c(%)/gF/hF)
  if (pDCB->isCharge()) {
    nValue = pDCB->GetResolution();	// obe[d
  } else {
    p++; 			// ŏ̗vf̓obe[d̂̂Ȃ̂Ŕ΂
    while (p->cIndex != -1) {
      if (nValue > p->cIndex) break;
      p++;
    }
  }
#else
  // BatteryFlagĐFς(eXg)
  while (p->cIndex != BATTERY_FLAG_UNKNOWN) {
    // ŏɃqbgXe[^XԂ
    if (pDCB->GetFlag()& p->cIndex) break;
    p++;
  }
  // ǂɂȂꍇUnknown
#endif
  pInfo  = &p->cInfo;
  return TRUE;
}
//----------------------------------------------------------------------
// gp
//
const BgEntry   BgMemory::pEntry =
  {_T("m"), {MEM_UPDATE,},{BAR_MINUPDATE,},
  (Bg *(__cdecl *const )(HWND,UINT,const BgSetting &)) &BgMemory::Create,};
const ColorInfo BgMemory::pColor =
  {RGB(0xcc,0xcc,0x00), RGB(0xff,0xff,0x00), RGB(0x00,0x00,0x00),};

BgMemory::BgMemory(HWND hWnd, UINT nUnique, const BgSetting &pSetting) :
  Bg(nUnique, pSetting.nHeight)
{
  SetFixWidth(0);
  pInfo = &pColor;
  pDC = new DCMemory(100,GetParameter(pEntry,pSetting, 0));
  pDC->SetMessage(TRUE, hWnd, GetUserMessageID());
  pDC->Start();
}
BgMemory *BgMemory::Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting)
{
  return new BgMemory(hWnd, nUnique, pSetting);
};
#if 0
BOOL BgMemory::MessageHandler(HWND hWnd,
			      UINT msg, WPARAM wParam, LPARAM lParam)
{
  DCMemory *pDCM = static_cast<DCMemory *> (pDC);

  nValue  = lParam;
  nStatus = pDCM->GetFree();	// GetFree邽߂ɕKv...ǎgĂȂ
  return TRUE;
}
#endif
//----------------------------------------------------------------------
// CPUgp
//
const BgEntry   BgCPU::pEntry =
  {_T("l"), {CPU_UPDATE,CPU_MEASUREPERIOD,},{BAR_MINUPDATE,BAR_MINUPDATE},
  (Bg *(__cdecl *const )(HWND,UINT,const BgSetting &)) &BgCPU::Create,};
const ColorInfo BgCPU::pColor =
  {RGB(0x44,0xcc,0x44), RGB(0x00,0xcc,0x00), RGB(0x00,0x00,0x00),};

BgCPU::BgCPU(HWND hWnd, UINT nUnique, const BgSetting &pSetting) :
  Bg(nUnique, pSetting.nHeight)
{
  SetFixWidth(0);
  pInfo = &pColor;
  pDC = new DCCPU(BARRESO,
		  GetParameter(pEntry,pSetting,0),
		  GetParameter(pEntry,pSetting,1));
  pDC->SetMessage(TRUE, hWnd, GetUserMessageID());
  pDC->Start();
}
BgCPU *BgCPU::Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting)
{
  return new BgCPU(hWnd, nUnique, pSetting);
}
//----------------------------------------------------------------------
// Xg[Wgp
//
const BgEntry   BgStorage::pEntry =
  {_T("sc"), {BAR_UPDATE,},{BAR_MINUPDATE,},
  (Bg *(__cdecl *const )(HWND,UINT,const BgSetting &)) &BgStorage::Create,};
const ColorInfo BgStorage::pColor = 
  {RGB(0x80,0x44,0x22), RGB(0xff,0x88,0x44), RGB(0x00,0x00,0x00),};

BgStorage::BgStorage(HWND hWnd, UINT nUnique, const BgSetting &pSetting, 
		     LPCTSTR lpPath) :
  Bg(nUnique, pSetting.nHeight)
{
  _tcsncpy(StoragePath, lpPath, sizeof(StoragePath)/sizeof(StoragePath[0]));
  SetFixWidth(0);
  pInfo = &pColor;
  pDC = new DCStorage(StoragePath, BARRESO, GetParameter(pEntry,pSetting, 0));
  pDC->SetMessage(TRUE, hWnd, GetUserMessageID());
  pDC->Start();
}
BgStorage *BgStorage::Create(HWND hWnd,UINT nUnique,const BgSetting &pSetting)
{
  LPTSTR lpPath;

  switch (pSetting.tcOption) {
  case _T('c'):
    {
      TCHAR tcPath[32];

      if (FAILED(RegistryGetString(HKEY_LOCAL_MACHINE,
				   STORAGE_REG_KEY,
				   FOLDER_REG_KEY,
				   tcPath, 32)))
	return NULL;
      lpPath =tcPath;
      break;
    }
  case _T('s'):
    lpPath = _T("\\");
    break;
  default:
    return NULL;
  }
  return new BgStorage(hWnd, nUnique, pSetting, lpPath);
}

//----------------------------------------------------------------------
// ʐM
//
const BgEntry   BgTraffic::pEntry =
  {_T("t"), {BAR_UPDATE, NET_MEASUREPERIOD,},{BAR_MINUPDATE, BAR_MINUPDATE,},
  (Bg *(__cdecl *const )(HWND,UINT,const BgSetting &)) &BgTraffic::Create,};
const DrawTable BgTraffic::pInfoTbl[] = {
  {10,		// brown (1)
   {RGB(0x88,0x88,0x88), RGB(0x99,0x00,0x00), RGB(0x00,0x00,0x00),},},
  {100,		// red (2)
   {RGB(0x88,0x88,0x88), RGB(0xFF,0x00,0x00), RGB(0x00,0x00,0x00),},},
  {1000,	// orange (3)
   {RGB(0x88,0x88,0x88), RGB(0xFF,0x80,0x00), RGB(0x00,0x00,0x00),},},
  {10000,	// yellow (4)
   {RGB(0x88,0x88,0x88), RGB(0xFF,0xFF,0x00), RGB(0x00,0x00,0x00),},},
  {100000,	// green (5)
   {RGB(0x88,0x88,0x88), RGB(0x00,0x99,0x00), RGB(0x00,0x00,0x00),},},
  {1000000,	// blue (6)
   {RGB(0x88,0x88,0x88), RGB(0x00,0x00,0xFF), RGB(0x00,0x00,0x00),},},
  {10000000,	// purple (7)
   {RGB(0x88,0x88,0x88), RGB(0x99,0x00,0x99), RGB(0x00,0x00,0x00),},},
  {100000000,	// gray (8)
   {RGB(0x88,0x88,0x88), RGB(0x99,0x99,0x99), RGB(0x00,0x00,0x00),},},
  {-1,		// white (9)
   {RGB(0x88,0x88,0x88), RGB(0xFF,0xFF,0xFF), RGB(0x00,0x00,0x00),},},
};

BgTraffic::BgTraffic(HWND hWnd, UINT nUnique, const BgSetting &pSetting) :
  Bg(nUnique, pSetting.nHeight)
{
  SetFixWidth(0);
  pDC = DCTraffic::GetInstance(BARRESO,
			       GetParameter(pEntry,pSetting,0),
			       GetParameter(pEntry,pSetting,1));
  pDC->SetMessage(TRUE, hWnd, GetUserMessageID());
  hWndSaved = hWnd;
  pInfo  = &pInfoTbl[0].cInfo;
  nValue = 0;
}
BgTraffic::~BgTraffic()
{
  pDC->DelMessage(hWndSaved, GetUserMessageID());
  DCTraffic::ReleaseInstance(&pDC);
}
BgTraffic *BgTraffic::Create(HWND hWnd,UINT nUnique,const BgSetting &pSetting)
{
  return new BgTraffic(hWnd, nUnique, pSetting);
}

BOOL BgTraffic::MessageHandler(HWND hWnd,
			       UINT msg, WPARAM wParam, LPARAM lParam)
{
  const	DrawTable *p = pInfoTbl;

  // gtBbN擾
  DWORD dwValue = lParam;
  int   nReso   = pDC->GetResolution();
  // f[^XgA
  while (p->cIndex != -1) {
    if ((DWORD)p->cIndex > dwValue) break;
    p++;
  }
  nValue  = dwValue * nReso / p->cIndex;
#if 0
  nStatus = dwValue;
#endif
  pInfo   = &p->cInfo;
  return TRUE;
}

//----------------------------------------------------------------------
// VtgXe[^X
//
const BgEntry   BgShiftStatus::pEntry =
  {_T("k"), {0xFE, SHIFTSTATUS_WIDTH, }, {0x0, MIN_FIXWIDTH,},
   (Bg *(__cdecl *const)(HWND,UINT,const BgSetting &)) &BgShiftStatus::Create};
const ColorInfo BgShiftStatus::pColorTbl[] = {
  {RGB(0xEC,0x00,0x8C), RGB(0xF0,0x00,0xF0), RGB(0x00,0x00,0x00),}, // Hyper
  {RGB(0x00,0xAE,0xEF), RGB(0x00,0xF0,0xF0), RGB(0x00,0x00,0x00),}, // Shift
  {RGB(0x00,0xA6,0x51), RGB(0x00,0xF0,0x00), RGB(0x00,0x00,0x00),}, // Ctrl
};
BgShiftStatus::BgShiftStatus(HWND hWnd, UINT nUnique, 
			     const BgSetting &pSetting) :
  Bg(nUnique, pSetting.nHeight)
{
  SetFixWidth(GetParameter(pEntry,pSetting, 1));
  pSS = ShiftStatus::Create(NULL, 
			    GetParameter(pEntry,pSetting, 0),
			    hWnd, GetUserMessageID());
  nValue = 0;
}
Bg *BgShiftStatus::Create(HWND hWnd, UINT nUnique, const BgSetting &pSetting)
{
  return new BgShiftStatus(hWnd, nUnique, pSetting);
}
BOOL BgShiftStatus::Draw(HDC hdc)
{
  HGDIOBJ hPen, hBrush;	// X̃IuWFNgۑ
  int nPos  = nLeft;
  int nStep = nWidth / 3;

  hPen	 = SelectObject(hdc, CreatePen(PS_SOLID, 1, pColorTbl[0].cFrameColor));
  hBrush = SelectObject(hdc, CreateSolidBrush((nValue & 0x01)?
					      pColorTbl[0].cBrushColor:
					      pColorTbl[0].cBlankColor));
  Rectangle(hdc, nPos, 0, (nPos+nStep), nHeight);
  nPos += nStep;

  DeleteObject(SelectObject(hdc, CreatePen(PS_SOLID, 1,
					   pColorTbl[1].cFrameColor)));
  DeleteObject(SelectObject(hdc, CreateSolidBrush((nValue & 0x02)?
						  pColorTbl[1].cBrushColor:
						  pColorTbl[1].cBlankColor)));
  Rectangle(hdc, nPos, 0, (nPos+nStep), nHeight);
  nPos += nStep;

  DeleteObject(SelectObject(hdc, CreatePen(PS_SOLID, 1,
					   pColorTbl[2].cFrameColor)));
  DeleteObject(SelectObject(hdc, CreateSolidBrush((nValue & 0x04)?
						  pColorTbl[2].cBrushColor:
						  pColorTbl[2].cBlankColor)));
  Rectangle(hdc, nPos, 0, nRight, nHeight);

  DeleteObject(SelectObject(hdc, hBrush));	// IuWFNgɖ߂
  DeleteObject(SelectObject(hdc, hPen));
  return TRUE;
}
