#include <windows.h>
#include <tchar.h>
#include "DataSetting.h"
#include "Bg.h"
#include "Bar.h"
//----------------------------------------------------------------------
#if 1
LRESULT CALLBACK Bar::WndProc(HWND hWnd, 
			      UINT msg, WPARAM wParam, LPARAM lParam)
{   
  Bar *pBar;

  // [N擾
  pBar = (Bar *) GetWindowLong(hWnd, GWL_USERDATA);

  if ((msg >= WM_USER)&&(msg < 0x8000)) {
    // WM_USER (WM_USER`0x7FFF)
    pBar->UserMessageHandler(hWnd, msg, wParam, lParam);
  } else {
    switch (msg) {
    case WM_CREATE:
      if ((pBar = Bar::Allocate(hWnd, 
				(const BarEntry*)
				(((CREATESTRUCT*)lParam)->lpCreateParams)))
	  == NULL) return -1;
      // [Ni[
      SetWindowLong(hWnd, GWL_USERDATA, (LONG)pBar);
      break;

    case WM_TIMER:
      // Xe[^XXV & o[` 
      pBar->TimerMessageHandler(hWnd, msg, wParam, lParam);
      break;

    case WM_PAINT:
      pBar->Redraw(hWnd);		// ĕ`
      break;

    case WM_APP:
      // wParam Mode
      // lParam Index
      pBar->SelectSetting(hWnd, wParam, lParam);
      break;

    case WM_APP_SETTINGCHANGE:
      // WM_SETTINGCHANGE:
      // o[ʒu̍XV
      if (wParam==SETTINGCHANGE_RESET) pBar->UpdateGeometry(hWnd);
      break;

    case WM_APP_CLOSE:
      // WM_CLOSE:
      delete pBar;
      DestroyWindow(hWnd);		// EBhEj
      break;

    case WM_DESTROY:
      break;

    default:
      return (DefWindowProc(hWnd, msg, wParam, lParam));
    }
  }
  return 0;
}
ATOM Bar::atmClass = 0;
ATOM Bar::GetWndCls(LPCTSTR lpClass, HINSTANCE hInstance)
{
  if (atmClass == 0) {
    WNDCLASS wc;

    // EBhENX`
    wc.style	     = CS_NOCLOSE;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon	     = NULL;
    wc.hCursor	     = NULL;
    wc.hbrBackground = NULL;
    wc.lpszMenuName  = NULL; 
    wc.lpszClassName = lpClass;
    atmClass = RegisterClass(&wc);
  }
  return atmClass;
}
HWND Bar::Create(const BarEntry *pEntry, BOOL bChild,
		 LPCTSTR lpClass, HINSTANCE hInstance, int nCmdShow)
{
  HWND hWnd;
  ATOM atom;

  // EBhENX擾łȂ΃G[
  if ((atom = GetWndCls(lpClass, hInstance))==0) return 0;
  // EBhE𐶐
  if ((hWnd = CreateWindowEx(WS_EX_TOPMOST|WS_EX_NOACTIVATE,
			     (LPCTSTR) atom,
			     NULL,
			     bChild?(WS_VISIBLE|WS_CHILD):(WS_VISIBLE|WS_POPUP),
			     0,0,0,0,
			     FindWindow(pEntry->lpParentClsName, NULL),
			     NULL,
			     hInstance,
			     (LPVOID) pEntry))!=NULL) {
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
  }
  return hWnd;
}
#endif
