#ifndef __BARGRAPH_H__
#define __BARGRAPH_H__

#include <windows.h>
#include <tchar.h>
#include "DataSetting.h"
#include "Bg.h"
//----------------------------------------------------------------------
// EBhEbZ[W
#define WM_APP_SETTINGCHANGE	WM_APP+1
#define WM_APP_CLOSE		WM_APP+2
//----------------------------------------------------------------------
// \
typedef enum {
  TASKBAR,
  TASKBARL,
  MENUBAR,
} BARATTRIBUTE;

struct BarEntry {
  BARATTRIBUTE eAttrib;		 // 
  TCHAR	       tcOption;	 // R}hCTuIvV
  LPCTSTR      lpEventName;	 // ؂ւCxg/EBhE
  LPCTSTR      lpParentClsName;	 // LEBhẼNX
  BOOL	       bChild;		 // qEBhEɂȂ邩ǂ
  LPCTSTR      lpRegistry;	 // WXgL[
  LPCTSTR      lpDefaultOptions; // ݒl(IvV)
};
//----------------------------------------------------------------------

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

class Bar {
 private:
  // ɂŏ
  const BarEntry *pEntry;	// o[̑
  int nFixWidthTotal;		// Œ蒷o[Ot̍̕v
  int nGraphNum;		// ϒo[Ot̐
  int nNum;			// o[Ot̐
  pBg *BG;			// o[Ot̏
  Registry *pRegistry;		// f[^ZbgǗ

  // UpdateGeometry()ōXV
  int nX, nY;
  int nHeight, nWidth;

  // g̐
  BOOL Generate(HWND hWnd, int nIdx) {
    DWORD dwSize;
    BarSetting *pBS;
    BgSetting *pBGS;
    pBg *pBG;

    // ݒǂݍ
    if ((dwSize = pRegistry->Load(NULL, nIdx)) == 0) return FALSE;
    pBS = (BarSetting *) alloca(dwSize);
    pRegistry->Load(pBS, nIdx);

    // ݒ̔f
    nNum     = pBS->nNum;
    nHeight  = pBS->nHeight;
    pBGS     = pBS->BG;
    pBG = BG = new pBg[nNum];

    // o[Ot̐ƃf[^W
    nGraphNum = 0;
    nFixWidthTotal = 0;
    for (int i=0;i<nNum;i++) {
      if ((*pBG = Bg::Create(hWnd, i+1, *(pBGS++)))==NULL) {
	nNum--;
	i--;
	continue;
      }
      if ((*pBG)->isFixWidth()) { // Œ蕝o[Ot`FbN
	nFixWidthTotal += (*pBG)->GetFixWidth();
      } else {
	nGraphNum++;
      }
      pBG++;
    }
    return (nNum!=0);
  }
  // o[̊J
  BOOL Remove() {
    if (nNum!=0) {
      for (int i=0;i<nNum;i++) delete BG[i];
      nNum = 0;
    }
    delete [] BG;
    return TRUE;
  }

  Bar(HWND hWnd, const BarEntry *pEntryArg) {	// InitEventHandler();
    pEntry = pEntryArg;
    nNum   = 0;
    pRegistry = new Registry(pEntry);
   }
 public:
  ~Bar() {					// ExitEventHandler();
    delete pRegistry;
    Remove();
  }

 private:
  // EBhEɃNX𐶐
  static Bar *Allocate(HWND hWnd, const BarEntry *pEntryArg) {
    Bar *pB;

    pB = new Bar(hWnd, pEntryArg);
    if (! pB->Generate(hWnd, pB->pRegistry->Select(0, -1))) {
      delete pB;
      return NULL;
    }
    pB->UpdateGeometry(hWnd);
    return pB;
  }
  // APP bZ[W̃nh
  BOOL SelectSetting(HWND hWnd,int mode = 0, int nIdx = 0) {
    if ((nIdx = pRegistry->Select(mode, nIdx))!=-1) {
      // o[̍폜
      if (!Remove()) return FALSE;
      // o[̐
      if (!Generate(hWnd, nIdx)) return FALSE;
      // o[̃WIgvZ
      UpdateGeometry(hWnd);
    }
    return TRUE;
  }
  // USER bZ[W̃nh
  void  UserMessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    int nID = msg-WM_USER;

    if (BG[nID]->MessageHandler(hWnd, msg, wParam, lParam))
      BG[nID]->Draw(hWnd);
  }
  // TIMER bZ[W̃nh
  void  TimerMessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
    int nID = wParam-1;

    if (BG[nID]->MessageHandler(hWnd, msg, wParam, lParam))
      BG[nID]->Draw(hWnd);
  }
  // WIg̍XV
  void  UpdateGeometry(HWND hWnd) {
    int nPos, nBarlen;
    RECT Rect;

    // ʂɍ킹ăo[Ŝ̍WČvZ
    nX     = 0;
    nWidth = GetSystemMetrics(SM_CXSCREEN);

    switch (pEntry->eAttrib) {
    case TASKBAR:
      nY = 0;
      break;
    case TASKBARL:
      GetWindowRect(GetParent(hWnd), &Rect);	// eEBhẺ
      nY = Rect.bottom - nHeight;
      break; 
    case MENUBAR:
      nY = GetSystemMetrics(SM_CYSCREEN) - nHeight;
      break;
    }

    nPos	  = 0;
    nBarlen = (nGraphNum!=0)?((nWidth-nFixWidthTotal)/nGraphNum):0;
    for (int i=0; i<nNum; i++) nPos = BG[i]->SetGeometry(nPos, nBarlen);
    BG[nNum-1]->SetGeometry(nWidth);

    // ʕɍ킹ăo[Ŝړ
    SetWindowPos(hWnd, HWND_TOPMOST, 
		 nX,
		 nY,
		 nWidth,
		 nHeight,
		 SWP_NOACTIVATE);

    // ŜCof[gčĕ`𑣂
    InvalidateRect(hWnd, NULL, TRUE);
  };

  // ĕ`
  void  Redraw(HWND hWnd) {
    HDC hdc;
    PAINTSTRUCT Paint;

    hdc = BeginPaint(hWnd, &Paint);
    for (int i=0;i<nNum;i++) BG[i]->Draw(hdc);
    EndPaint(hWnd, &Paint);
  }

  // EBhE
 public:
  static HWND Create(const BarEntry *pEntry, BOOL bChild,
		     LPCTSTR lpClass, HINSTANCE hInstance, int nCmdShow);
 private:
  static ATOM atmClass;
  static ATOM GetWndCls(LPCTSTR lpClass, HINSTANCE hInstance);
  static LRESULT CALLBACK WndProc(HWND hWnd, 
				  UINT msg, WPARAM wParam, LPARAM lParam);
};
#endif
