#pragma comment(lib, "Iphlpapi.lib")
#pragma comment(lib, "aygshell.lib")

#include <windows.h>
#include <iphlpapi.h>
#pragma warning(disable:4819)	// regext.h
#include <regext.h>
#pragma warning(default:4819)	// regext.h
#include "Collection.h"
//-----------------------------------------------------------------------------
// DataCollection Class Function
//
DataCollection::DataCollection(DWORD dwResoArg,
			       DWORD dwPeriodArg,
			       BOOL  bIdle)
{
  // p[^
  dwResolution = dwResoArg;
  dwPeriod     = dwPeriodArg;
  nPriority    = bIdle?THREAD_PRIORITY_IDLE:THREAD_PRIORITY_NORMAL;

  // o
  dwData  = 1;
  hEvents = NULL;
}
DataCollection::~DataCollection()
{
  if (hEvents != NULL) {		// Terminate
    Action(TERMINATE);
    if (WaitForSingleObject(hThread, 10000) == WAIT_TIMEOUT)
      TerminateThread(hThread,1);
    CloseHandle(hThread);
  }
}
void DataCollection::Start()
{
  if (dwPeriod == INFINITE) return;	// Error
  if (hEvents != NULL) {		// Resume
    Action(RESUME);
  } else {				// Start
    hThread = CreateThread(NULL, 0, DataCollection::DataCollectThread, this, 
			   0, NULL);
  }
}
DWORD DataCollection::DataCollectThread(LPVOID lpVoid)
{
  DataCollection *t = ((DataCollection *) lpVoid);
  HANDLE *hEvents;
  BOOL bReset;

  SetThreadPriority(GetCurrentThread(), t->nPriority);
  hEvents = (HANDLE *)alloca(sizeof(HANDLE)*MAXEVTDC);
  for (int i=0;i<MAXEVTDC;i++) hEvents[i]=CreateEvent(NULL,FALSE,FALSE,NULL);
  t->hEvents = hEvents;
  t->dwTimeout = t->dwPeriod;		// |[OJn
  t->InitDataCollect();
  while (TRUE) {
    bReset = FALSE;
    switch (WaitForMultipleObjects(MAXEVTDC, hEvents, FALSE, t->dwTimeout)) {
    case WAIT_OBJECT_0+TERMINATE:	// I
      t->TermDataCollect();
      for (int i=0; i<MAXEVTDC; i++) CloseHandle(hEvents[i]);
      t->hEvents = NULL;
      return 0;
    case WAIT_OBJECT_0+SUSPEND:		// ~
      t->dwTimeout = INFINITE;
      t->Message.Send(TRUE, 0);			// 0ʒmĒ~
      break;
    case WAIT_OBJECT_0+RESUME:		// ĊJ
      t->dwTimeout = t->dwPeriod;
      break;
    case WAIT_OBJECT_0+MODIFY:		// ݒύXʒm
      if (t->dwTimeout != INFINITE) t->dwTimeout = t->dwPeriod;
      SetThreadPriority(GetCurrentThread(), t->nPriority);
      bReset = TRUE;
      // FallThrough
    case WAIT_TIMEOUT:			// 
      BOOL bChanged;
      DWORD dwResult;

      bChanged = (t->dwData != (dwResult=t->DataCollect(bReset)));
      t->dwData = dwResult;
      t->Message.Send(bChanged, dwResult);
      break;
    default:
      break;
    }
  }
}
//-----------------------------------------------------------------------------
// NetTraffic Class Function
//
// WXg
// HKEY_LOCAL_MACHINE
#define CONNECT_REG_KEY	       _T("System\\State\\Connections")
#define COUNT_REG_KEY	       _T("Count")

DCTraffic *DCTraffic::Instance = NULL;
int DCTraffic::nCount;
DCTraffic *DCTraffic::GetInstance(DWORD dwResoArg,
		       DWORD dwPeriodArg,
		       DWORD dwMeasureArg,
		       BOOL  bIdle)
{
  if (Instance == NULL) {
    Instance = new DCTraffic(dwResoArg, dwPeriodArg, dwMeasureArg, bIdle);
    nCount = 1;
  } else {
    nCount++;
    Instance->SetResolution(dwResoArg);
    Instance->SetPeriod(dwPeriodArg);
    Instance->SetMeasure(dwMeasureArg);
    Instance->SetPriority(bIdle?THREAD_PRIORITY_IDLE:THREAD_PRIORITY_NORMAL);
  } 
  return Instance;
}
BOOL DCTraffic::ReleaseInstance(DataCollection **p) {
  if (*p == Instance) {
    if (--nCount == 0) {	// NgĂȂȂ
      delete Instance;		// 폜
      *p = Instance = NULL;
      return TRUE;
    }
  }
  return FALSE;
}
DCTraffic::DCTraffic(DWORD dwResoArg,
		     DWORD dwPeriodArg,
		     DWORD dwMeasureArg,
		     BOOL  bIdle) : DCFIFO(dwResoArg,
					   dwPeriodArg,
					   dwMeasureArg,
					   bIdle)
{
  DWORD dwData;

  dwEntries = 0;
  RegistryNotifyCallback(HKEY_LOCAL_MACHINE,
			 CONNECT_REG_KEY,
			 COUNT_REG_KEY,
			 RegistryCB,
			 NULL,
			 NULL, &hNotify);
  if (SUCCEEDED(RegistryGetDWORD(HKEY_LOCAL_MACHINE,
				 CONNECT_REG_KEY,
				 COUNT_REG_KEY,
				 &dwData))&&
      (dwData!=0))
    Start();
};
void DCTraffic::RegistryCB(HREGNOTIFY hNotify, DWORD dwUserData,
			   const PBYTE pData, const UINT cbData) {
  if ((pData==NULL)||(cbData!=sizeof(DWORD))) return;
  if (*((PDWORD)pData)!=0)
    Instance->Start();
  else
    Instance->Stop();
}
DWORD DCTraffic::DataCollect(BOOL bReset)
{
  PMIB_IFTABLE sMIBTable;
  DWORD dwTraffic;
  DWORD dwSize;
  DWORD dwCounter, dwTick;

  if (bReset) fData->Resize(CalFIFOSiz());

  dwSize = 0; GetIfTable(NULL, &dwSize, FALSE);
  sMIBTable = (PMIB_IFTABLE) alloca(dwSize);
  sMIBTable->dwNumEntries = 0;
  if ((SUCCEEDED(GetIfTable(sMIBTable, &dwSize, FALSE))) &&
      (dwEntries == sMIBTable->dwNumEntries)) {
    DWORD dwCounterNew = 0;
    PMIB_IFROW sMIB = sMIBTable->table;

    for (DWORD i=0;i<sMIBTable->dwNumEntries;i++) {
      if (sMIB->dwType == IF_TYPE_SOFTWARE_LOOPBACK) continue;
      dwCounterNew += (sMIB->dwInOctets + sMIB->dwOutOctets);
      sMIB++;
    }
    fData->Get(dwCounter, dwTick);
    fData->Set(dwCounterNew);
    // dwTraffic [byte/s]
    dwTraffic = (((dwCounterNew - dwCounter) * 1000 / dwTick));
  } else {
    dwEntries = sMIBTable->dwNumEntries;
    dwTraffic = 0;
    fData->Reset();
  }
  return dwTraffic;
}
//-----------------------------------------------------------------------------
// CPU Class Function
//
DWORD DCCPU::DataCollect(BOOL bReset)
{
  DWORD dwReso = GetResolution();
  DWORD dwIdleNew;
  DWORD dwIdle, dwTick;

  if (bReset) fData->Resize(CalFIFOSiz());

  dwIdleNew = GetIdleTime();
  fData->Get(dwIdle, dwTick);
  fData->Set(dwIdleNew);
  return dwReso-((dwReso*(dwIdleNew-dwIdle)) / dwTick);
}
//-----------------------------------------------------------------------------
// Storage Class Function
//
DWORD DCStorage::DataCollect(BOOL bReset)
{
  DWORD dwReso = GetResolution();
  ULARGE_INTEGER lpFreeBytesAvailableToCaller;
  ULARGE_INTEGER lpTotalNumberOfBytes;
  ULARGE_INTEGER lpTotalNumberOfFreeBytes;

  if (GetFileAttributes(pszPath) != -1) {
    // eʎ擾
    GetDiskFreeSpaceEx(pszPath,
		       &lpFreeBytesAvailableToCaller, 
		       &lpTotalNumberOfBytes, 
		       &lpTotalNumberOfFreeBytes);
  } else {
    // foCXȂ
    lpTotalNumberOfBytes.QuadPart = 1;
    lpTotalNumberOfFreeBytes.QuadPart = 1;
  }
  dwFree  = (DWORD)(lpTotalNumberOfFreeBytes.QuadPart/(1024*1024));
  return dwReso - (DWORD)((dwReso*lpTotalNumberOfFreeBytes.QuadPart)
			  /lpTotalNumberOfBytes.QuadPart);
}
//-----------------------------------------------------------------------------
// Memory Class Function
//
DWORD DCMemory::DataCollect(BOOL bReset)
{
  DWORD dwReso = GetResolution();
  MEMORYSTATUS lpMemory;

  GlobalMemoryStatus(&lpMemory);
  dwFree = lpMemory.dwAvailPhys/(1024*1024);
  return dwReso * lpMemory.dwMemoryLoad / 100;
}
//-----------------------------------------------------------------------------
// Battery Class Function
//
DWORD DCBattery::DataCollect(BOOL bReset)
{
  DWORD dwReso = GetResolution();
  SYSTEM_POWER_STATUS_EX pst;

  // ݂̓dԂ擾
  if (GetSystemPowerStatusEx(&pst, TRUE)) {
    nFlag   = pst.BatteryFlag;
    nValue  = pst.BatteryLifePercent;
    if (pst.BatteryLifePercent == BATTERY_FLAG_UNKNOWN) nValue = 0;
    if (isCharge()) nValue = 101;
  }
  return dwReso * nValue / 100;
}
