#ifndef __COLLECTION_H__
#define __COLLECTION_H__

#include <windows.h>
#include <tchar.h>
#pragma warning(disable:4819)	// regext.h
#include <regext.h>
#pragma warning(default:4819)

//-----------------------------------------------------------------------------
// enumulator
//
enum DataCollectionEvents {
  TERMINATE = 0,	// I
  SUSPEND = 1,		// ~
  RESUME = 2,		// Jn/ĊJ
  MODIFY = 3,		// dwPeriod/dwMesureȂǂύXꂽƂɒʒm
  MAXEVTDC = 4,		// Max
};
//-----------------------------------------------------------------------------
// MessageManager class
//
class DataCollectionMessage {
  DataCollectionMessage *next;
  BOOL   bAlways;	// T:f[^̍XV̂тɃbZ[W𓊂
  HWND   hWnd;		// F:IdlełȂȂƂɃbZ[W𓊂
  UINT   nMsg;
  WPARAM wParam;
 public:
  DataCollectionMessage() {
    next = NULL;
    hWnd = NULL;
  }
  ~DataCollectionMessage() {
    if (next != NULL) delete next;
  }
  void Add(BOOL bModeA,
	   HWND hWndA,UINT nMsgA,WPARAM wParamA=0) {
    if ((hWnd == NULL)||((hWnd == hWndA)&&(nMsg == nMsgA)&&(wParam = wParamA))){
      bAlways = bModeA;
      hWnd    = hWndA;
      nMsg    = nMsgA;
      wParam  = wParamA;
    } else {
      if (next == NULL) next = new DataCollectionMessage;
      next->Add(bModeA, hWndA, nMsgA, wParamA);
    }
  }
  void Del(HWND hWndA,int nMsgA,WPARAM wParamA=0) {
    if ((hWnd == hWndA)&&(nMsg == nMsgA)&&(wParam = wParamA)) {
      hWnd = NULL;
    } else if (next != NULL) {
      next->Del(hWndA, nMsgA, wParamA);
    }
  }
  void Send(BOOL bChanged, DWORD dwValue) {
    if ((hWnd!=NULL)&&(bAlways?bChanged:(dwValue!=0)))
      PostMessage(hWnd, nMsg, wParam, bAlways?dwValue:0);
    if (next != NULL) next->Send(bChanged, dwValue);
  }
};
//-----------------------------------------------------------------------------
// FIFO Class
//
class FIFO {
 private:
  DWORD *dwCounter;
  DWORD *dwTick;
  int    nFIFOsiz, nFIFOp;
 public:
  FIFO(int n=2) {
    nFIFOp    = 0;
    nFIFOsiz  = n;
    dwCounter = new DWORD[nFIFOsiz];
    dwTick    = new DWORD[nFIFOsiz];
    Reset();
  }
  ~FIFO() {
    delete [] dwTick;
    delete [] dwCounter;
  }
  void Get(DWORD &dwValue, DWORD &dwTickArg) {
    int nOldest = (nFIFOp+1) % nFIFOsiz;

    dwValue        = dwCounter[nOldest];
    dwTick[nFIFOp] = GetTickCount();
    dwTickArg      = dwTick[nFIFOp] - dwTick[nOldest];
  }
  void Set(DWORD dwValue) {
    dwCounter[nFIFOp] = dwValue;
    nFIFOp = (nFIFOp+1) % nFIFOsiz;
  }
  void Resize(int n=2) {
    if (nFIFOsiz != n) {
      nFIFOsiz  = n;

      delete [] dwTick;
      delete [] dwCounter;
      dwCounter = new DWORD[nFIFOsiz];
      dwTick    = new DWORD[nFIFOsiz];
    }
    Reset();
  }
  void Reset() {
    nFIFOp = 0;
    for (int i=0;i<nFIFOsiz;i++) dwCounter[i] = dwTick[i] = 0;
  }
};
//-----------------------------------------------------------------------------
// DataCollection Class
//
class DataCollection {
 private:
  DWORD	 dwData;			// Wꂽf[^
  HANDLE hThread;			// Xbh
  HANDLE *hEvents;			// Cxg
  DWORD  dwPeriod;			// f[^|[OԊu
  DWORD  dwTimeout;			// ݂̃^CAEg
  DWORD  dwResolution;			// f[^̉𑜓x
  DataCollectionMessage Message;	// CxgŃbZ[W𓊂
  int    nPriority;			// Xbh̃vCIeB
 private:
  // Thread member
  static  DWORD DataCollectThread(LPVOID lpVoid); 
  virtual BOOL  InitDataCollect() { return TRUE; }
  virtual DWORD DataCollect(BOOL bReset) = 0;
  virtual BOOL  TermDataCollect() { return TRUE; }
 protected:
  DataCollection(DWORD dwResoArg    = 1000,	// f[^𑜓x
		 DWORD dwPeriodArg  = INFINITE,	// XVԊu
		 BOOL  bIdle        = TRUE);	// vCIeBIdletO
  void  Action(DataCollectionEvents eEvt) {
    SetEvent(hEvents[eEvt]);
  }
  void  Modify() {			// p[^ύX̒ʒm
    if (hEvents!=NULL) Action(MODIFY);
  }
 public:
  // Jo[
  virtual ~DataCollection();
  // Thread Control
  void  Start();			// Ď̊Jn
  void  Stop() { 		 	// Ď̋x~
    if (hEvents!=NULL) Action(SUSPEND);
  }
  // accesser
  //DWORD GetData() { return dwData; }
  void  SetPeriod(DWORD dwPeriodArg) {
    dwPeriod  = dwPeriodArg;		// XVԊu̐ݒ
    Modify();
  }
  DWORD GetPeriod() { return dwPeriod; }
  void  SetPriority(int nPriorityArg) {	// vCIeB
    nPriority = nPriorityArg;
    Modify();
  }
  void  SetResolution(DWORD dwValue) {	// f[^𑜓x̐ݒ
    dwResolution = dwValue;
    Modify();
  }
  DWORD GetResolution() {		// f[^𑜓x̎擾
    return dwResolution;
  }
  // f[^XVCxgݒ
  void  SetMessage(BOOL bMode, HWND hWnd, UINT nMsg, WPARAM wParam=0) {
    Message.Add(bMode, hWnd, nMsg, wParam);
  }
  // f[^XVCxg폜
  void  DelMessage(HWND hWnd,int nMsg, WPARAM wParam=0)  {
    Message.Del(hWnd, nMsg, wParam);
  }
};
//-----------------------------------------------------------------------------
// DataCollection With FIFO Class

class DCFIFO : public DataCollection {
 protected:
  FIFO *fData;
 private:
  DWORD dwMeasure;			// f[^Ԋu
  BOOL  InitDataCollect() {
    fData = new FIFO(CalFIFOSiz());
    return TRUE;
  };
  BOOL  TermDataCollect() {
    delete fData;
    return TRUE;
  };
 protected:
  DCFIFO(DWORD dwResoArg    = 1000,
	 DWORD dwPeriodArg  = INFINITE,
	 DWORD dwMeasureArg = 0,
	 BOOL  bIdle        = FALSE) : DataCollection(dwResoArg,
						      dwPeriodArg,
						      bIdle) {
    dwMeasure = dwMeasureArg;
  };
  int CalFIFOSiz() {
    return ((GetPeriod()>dwMeasure)?2:(dwMeasure/GetPeriod()+1));
  }
 public:
  void SetMeasure(DWORD dwMeasureA) {
    dwMeasure = dwMeasureA; 
    Modify();
  };
};
//-----------------------------------------------------------------------------
// Dummy Class
class DCDummy : public DataCollection {
  DWORD DataCollect(BOOL bReset) { return 0; }
 public:
  DCDummy(DWORD dwResoArg = 1000) : DataCollection(dwResoArg) {};
};
//-----------------------------------------------------------------------------
// NetTraffic Class
//
class DCTraffic : public DCFIFO {
 private:
  static DCTraffic *Instance;
  static int nCount;
  DWORD dwEntries;
  HREGNOTIFY hNotify;

  // f[^W[`{
  DWORD DataCollect(BOOL bReset);
  static void RegistryCB(HREGNOTIFY hNotify, DWORD dwUserData,
			 const PBYTE pData, const UINT cbData);
 protected:
  DCTraffic(DWORD dwResoArg    = 1000, DWORD dwPeriodArg  = INFINITE,
	    DWORD dwMeasureArg = 0,    BOOL  bIdle        = FALSE);
  ~DCTraffic() {
    if (hNotify!=NULL) RegistryCloseNotification(hNotify);
  }
 public:
  static DCTraffic *GetInstance(DWORD dwResoArg,
				DWORD dwPeriodArg  = INFINITE,
				DWORD dwMeasureArg = 0,
				BOOL  bIdle        = TRUE);
  static BOOL ReleaseInstance(DataCollection **p);
};
//-----------------------------------------------------------------------------
// CPU Class
//
class DCCPU : public DCFIFO {
 private:
  // f[^W[`{
  DWORD DataCollect(BOOL bReset);
 public:
  DCCPU(DWORD dwResoArg    = 1000,
	DWORD dwPeriodArg  = INFINITE,
	DWORD dwMeasureArg = 0,
	BOOL  bIdle        = FALSE) : DCFIFO(dwResoArg,
					     dwPeriodArg,
					     dwMeasureArg,
					     bIdle){};
};
//-----------------------------------------------------------------------------
// Storage Class
//
class DCStorage : public DataCollection {
 private:
  LPCTSTR pszPath;
  DWORD dwFree;

  // f[^W[`{
  DWORD DataCollect(BOOL bReset);
 public:
  DCStorage(LPCTSTR lpPath,
	    DWORD dwResoArg    = 1000,
	    DWORD dwPeriodArg  = INFINITE,
	    BOOL  bIdle        = TRUE) : DataCollection(dwResoArg,
							dwPeriodArg,
							bIdle) {
    pszPath = lpPath;
    dwFree  = 0;
  };
  // accesser
  void  SetPath(LPCTSTR lpPath) { pszPath = lpPath; Modify(); }
  DWORD GetFree() { return dwFree; }
};
//-----------------------------------------------------------------------------
// Memory Class
//
class DCMemory : public DataCollection {
 private:
  DWORD dwFree;

  // f[^W[`{
  DWORD DataCollect(BOOL bReset);
 public:
  DCMemory(DWORD dwResoArg    = 100,
	   DWORD dwPeriodArg  = INFINITE,
	   BOOL  bIdle        = TRUE) : DataCollection(dwResoArg,
						       dwPeriodArg,
						       bIdle) {
    dwFree = 0;
  };
  DWORD GetFree() { return dwFree; }
};
//-----------------------------------------------------------------------------
// Battery Class
//
class DCBattery : public DataCollection {
 private:
  BYTE  nFlag;
  DWORD nValue;

  // f[^W[`{
  DWORD DataCollect(BOOL bReset);
 public:
  DCBattery(DWORD dwResoArg    = 100,
	    DWORD dwPeriodArg  = INFINITE,
	    BOOL  bIdle        = TRUE) : DataCollection(dwResoArg,
							dwPeriodArg,
							bIdle) {
    nValue  = 0;
    nFlag   = 0;
  }
  BOOL isCharge() { return nFlag & BATTERY_FLAG_CHARGING; }
  BYTE GetFlag()  { return nFlag; }
};
#endif
