#ifndef __DATASETTING_H__
#define __DATASETTING_H__

#include <windows.h>
#include <tchar.h>

// WXgL[
#define APP_REGISTRY	   _T("Software\\DevStatusBar")

// WXg`o[W
#define REGREVISION	   0
#define REGVERSION         (REGREVISION<<4|MAXPARAMNUM)

// o[̐ݒ
#define MAXPARAMNUM	   3	// o[Oẗ̍ől
#define DEFAULT_HEIGHT	   5	// o[̍
//----------------------------------------------------------------------
struct BgSetting {
  TCHAR tcOption;		// R}hCIvV()
  BOOL  bCaps;			// 啶w
  int   nHeight;
  int   nParam[MAXPARAMNUM];	// XVԊu/o[Ot̕/0ŃftHg
};
struct BarSetting {
  int nNum;
  int nHeight;
#pragma warning(disable:4200)	// TCY0̔z̋
  BgSetting BG[];
#pragma warning(default:4200)
};

struct OptionEntry {
  LPCTSTR lpOptions;
  int nLen;
  BOOL bSubOption;	// TuIvVF߂邩
  BOOL bArg;		// F߂邩
};

//----------------------------------------------------------------------
class Registry {
private:
  int nDefaultSet;		// WXgCfbNXl(0 or 1)
  int nCurrentSet;		// WXgCfbNX
  LPCTSTR lpDefaultOptions;	// ftHgIvV
  LPCTSTR lpSubKey;		// WXgTuL[
  HKEY  hKey;			// I[vσL[

  BOOL  Open();
  BOOL  Close();
  BOOL  SaveRaw(const BYTE *pData, DWORD dwSize, int nIdx);
  static DWORD GetRegistrySize(int nNum) {
    return (3+((nNum)*(1+1+4*MAXPARAMNUM)));
  }
  static DWORD GetSettingSize(int nNum) {
    return (sizeof(BarSetting)+sizeof(BgSetting)*nNum);
  }
public:
  Registry(const struct BarEntry *pBE);
  ~Registry();

  int   Select(int nMode, int nIdx=0);		
  DWORD Load(BarSetting *pBS, int nIdx);	// ǂݏo
  BOOL  Save(BarSetting *pBS, int nIdx);	// o
  BOOL  Delete(int nIdx);

  // R}hC
  static BOOL CommandLine(const struct BarEntry *pBE,
			  int nBarNum, int nMaxBGNum,
			  const struct OptionEntry *pOptions, int *nResults,
			  int nOptions,
			  LPTSTR lpCmdLine, int nIdx = 0);
};
#endif
