//****************************************************************************
// DevStatusBar Ver 0.11.4		959@Part81	21264A@gmail.com
//-----------------------------------------------------------------------------
// AvP[V̖O
#define APP_NAME	   _T("Dev_Status_Bar_Ver.0.11.4")
#define WATCHER_NAME	   _T("DSB_Watcher")
//-----------------------------------------------------------------------------
#pragma comment(lib, "aygshell.lib")

#include <windows.h>
#include <tchar.h>
#pragma warning(disable:4819)	// regext.h
#include <regext.h>
#pragma warning(default:4819)	// regext.h

#include "Collection.h"
#include "BG.h"
#include "Bar.h"
//----------------------------------------------------------------------
static const BarEntry BarEntryTbl[] = {
  {TASKBAR,  _T('+'), _T("DevStatusBarTask"),  _T("HHTaskBar"),    TRUE,
   _T("TaskBar"),  _T("rnbml"), },
  {MENUBAR,  _T('-'), _T("DevStatusBarMenu"),  _T("MS_SIPBUTTON"), FALSE,
   _T("MenuBar"),  _T(""),      },
  {TASKBARL, _T('*'), _T("DevStatusBarTaskL"), _T("HHTaskBar"),    TRUE,
   _T("TaskBarL"), _T(""),      },
};

#define BARNUM (sizeof(BarEntryTbl)/sizeof(BarEntryTbl[0]))
//*****************************************************************************
// WinMain
//
typedef struct __ThreadTerm {
  HANDLE hEvt;
  DWORD dwThreadID;
  HWND hWnd[BARNUM];
  HWND hWatcher;
} THREADTERM;

static DWORD ThreadTerminate(LPVOID lpVoid)
{
  THREADTERM *ptt = (THREADTERM *)lpVoid;

  // DxIDLEɗƂ
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_IDLE);
  // Cxg҂
  WaitForSingleObject(ptt->hEvt, INFINITE);
  CloseHandle(ptt->hEvt);
  // SEBhEWM_CLOSE𓊂ƂWM_QUIT𓊂
  for (int i=0; i<BARNUM; i++) {
    if (ptt->hWnd[i] != NULL) PostMessage(ptt->hWnd[i], WM_APP_CLOSE, 0, 0);
  }
  if (ptt->hWatcher) PostMessage(ptt->hWatcher, WM_APP_CLOSE, 0, 0);
  PostThreadMessage(ptt->dwThreadID, WM_QUIT, 0, 0);
  ExitThread(0);
  return TRUE;
}

static LRESULT CALLBACK WatchWndProc(HWND hWnd, 
				     UINT msg, WPARAM wParam, LPARAM lParam)
{   
  THREADTERM *ptt;

  // [N擾
  ptt = (THREADTERM *) GetWindowLong(hWnd, GWL_USERDATA);

  switch (msg) {
  case WM_CREATE:
    // [Ni[
    SetWindowLong(hWnd, GWL_USERDATA, 
		  (LONG)(((CREATESTRUCT*)lParam)->lpCreateParams));

  case WM_SETTINGCHANGE:
    // bZ[W̃[
    if (wParam==SETTINGCHANGE_RESET) {
      for (int i=0;i<BARNUM;i++) {
	if (ptt->hWnd[i] != NULL) 
	  PostMessage(ptt->hWnd[i], WM_APP_SETTINGCHANGE, wParam, lParam);
      }
    }
    break;

  case WM_APP_CLOSE:
    // WM_CLOSE:
    DestroyWindow(hWnd);
    break;

  case WM_DESTROY:
    break;

  default:
    return (DefWindowProc(hWnd, msg, wParam, lParam));
  }
  return 0;
}

static BOOL CreateWatcherWindow(THREADTERM *ptt, 
				HINSTANCE hInstance, int nCmdShow)
{
  ATOM atmWatch;
  WNDCLASS wc;

  // EBhENX`
  wc.style	   = CS_NOCLOSE;
  wc.lpfnWndProc   = WatchWndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon	   = NULL;
  wc.hCursor	   = NULL;
  wc.hbrBackground = NULL;
  wc.lpszMenuName  = NULL; 
  wc.lpszClassName = WATCHER_NAME;
  if ((atmWatch = RegisterClass(&wc))==0) return 0;

  ptt->hWatcher = CreateWindowEx(WS_EX_NOACTIVATE,
				 (LPCTSTR) atmWatch,
				 NULL,
				 (WS_POPUP),
				 0,0,0,0,
				 NULL,
				 NULL,
				 hInstance,
				 (LPVOID) ptt);
  return (ptt->hWatcher != NULL);
}

static const OptionEntry OptionsTbl[] = {
  {_T("wait"),    4, FALSE, TRUE,},
  {_T("nochild"), 7, FALSE, FALSE,},
  {_T("save"),    4, TRUE,  TRUE,},
  {_T("delete"),  6, TRUE,  TRUE,},
};
#define MAXOPTIONS (sizeof(OptionsTbl)/sizeof(OptionsTbl[0]))

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
		     LPTSTR    lpCmdLine, int	    nCmdShow)
{
  MSG msg;
  THREADTERM tt;
  HANDLE hThread, hEvt;
  int nRet;
  int nOption[MAXOPTIONS];

  // dN`FbN
  if ((hEvt = CreateEvent(NULL, FALSE, FALSE, APP_NAME))==NULL) return FALSE;
  if (GetLastError() == ERROR_ALREADY_EXISTS) {
    nRet = MessageBox(NULL, _T("풓܂H"), APP_NAME,
		      MB_YESNO|MB_ICONQUESTION|MB_TOPMOST);
    if (nRet == IDYES) SetEvent(hEvt);
    CloseHandle(hEvt);
    return TRUE;
  }

  // ݒ
  if (!Registry::CommandLine(BarEntryTbl, BARNUM, 10,
			     OptionsTbl, nOption, MAXOPTIONS,
			     lpCmdLine, 0)) {
    MessageBox(NULL, _T("IvVɌ肪܂"), APP_NAME, 
	       MB_OK|MB_ICONERROR);
    return FALSE;
  }

  if (nOption[0]!=0) Sleep(nOption[0]); // /wait nnnn

  // EBhE쐬
  for (int i=0; i<BARNUM; i++)
    tt.hWnd[i] = Bar::Create(&BarEntryTbl[i],
			     nOption[1]?FALSE:BarEntryTbl[i].bChild,
			     APP_NAME,hInstance,nCmdShow);

  // Iv҂󂯃Xbh쐬
  tt.hEvt = hEvt;
  tt.dwThreadID = GetCurrentThreadId();
  if ((hThread = CreateThread(NULL,0,ThreadTerminate,&tt,0,NULL))==NULL)
    return FALSE;
  CloseHandle(hThread);

  // ʏԊĎpEBhE
  CreateWatcherWindow(&tt, hInstance, nCmdShow);

  // bZ[W[v
  while (TRUE) {
    if ((nRet = GetMessage(&msg, NULL, 0, 0))==-1) continue;
    if (nRet == 0) break;
    DispatchMessage(&msg);
  }
  return msg.wParam;
}
