#ifndef __KEYHOOK_H__
#define __KEYHOOK_H__

#include <windows.h>

typedef LRESULT (CALLBACK* HOOKPROC)(int code, WPARAM wParam, LPARAM lParam);

#ifdef __cplusplus
extern "C" {
#endif
  HHOOK   WINAPI SetWindowsHookExW(int, HOOKPROC, HINSTANCE, DWORD);
  HHOOK   WINAPI SetWindowsHookExA(int, HOOKPROC, HINSTANCE, DWORD);
  LRESULT WINAPI CallNextHookEx(HHOOK, int, WPARAM, LPARAM);
  LRESULT WINAPI UnhookWindowsHookEx(HHOOK);
#ifdef __cplusplus
}
#endif

#ifdef UNICODE
#define SetWindowsHookEx SetWindowsHookExW
#else
#define SetWindowsHookEx SetWindowsHookExA 
#endif

typedef struct tagKBDLLHOOKSTRUCT {
  DWORD   vkCode;
  DWORD   scanCode;
  DWORD   flags;
  DWORD   time;
  ULONG_PTR dwExtraInfo;
} KBDLLHOOKSTRUCT, FAR *LPKBDLLHOOKSTRUCT, *PKBDLLHOOKSTRUCT;

#define WH_KEYBOARD_LL     20

#define HC_ACTION           0

#endif
