#include <windows.h>
#include <tchar.h>
#include "ShiftStatus.h"

ShiftStatus *ShiftStatus::Instance = NULL;
LRESULT CALLBACK ShiftStatus::LLKeyboardCB(int nCode,
					   WPARAM wParam, LPARAM lParam)
{
  ShiftStatus *t = Instance;

  if (nCode == HC_ACTION) {
    LPKBDLLHOOKSTRUCT pkbhs = (LPKBDLLHOOKSTRUCT) lParam;
    BOOL bEvent = FALSE;
    BOOL bKey;

    if (pkbhs->vkCode == t->kHyper) {
      if (((wParam == WM_KEYUP)  &&( t->kState.bHyper)) ||
	  ((wParam == WM_KEYDOWN)&&(!t->kState.bHyper))) {
	t->kState.bHyper = !t->kState.bHyper;
	bEvent = TRUE;
      }
    }
    bKey = GetAsyncKeyState(VK_SHIFT) & 0x8000U;
    if (((!bKey)&&( t->kState.bShift)) ||
	(( bKey)&&(!t->kState.bShift))) {
      t->kState.bShift = !t->kState.bShift;
      bEvent = TRUE;
    }
    bKey = GetAsyncKeyState(VK_CONTROL) & 0x8000U;
    if (((!bKey)&&( t->kState.bCtrl)) ||
	(( bKey)&&(!t->kState.bCtrl))) {
      t->kState.bCtrl = !t->kState.bCtrl;
      bEvent = TRUE;
    }

    // Report State Change
    if (bEvent) PostMessage(t->hWnd, t->nMsg, 0, t->kState.kState);
  }
  return CallNextHookEx(t->hHook, nCode, wParam, lParam);
}
