#ifndef __SHIFTSTATUS_H__
#define __SHIFTSTATUS_H__

#include <windows.h>
#include "keyhook.h"

////////////////////////////////////////////////////////////////////////
union ShiftState {
  struct {
    BOOL bHyper:1;
    BOOL bShift:1;
    BOOL bCtrl:1;
  };
  UINT kState;
};

class ShiftStatus {
 private:
  static ShiftStatus *Instance;

  // ShiftStatus
  HHOOK hHook;
  int  kHyper;
  ShiftState kState;

  // Window Message
  HWND hWnd;
  UINT nMsg;

  ShiftStatus(HINSTANCE hInst) {
    kState.kState = 0;
    hHook = SetWindowsHookEx(WH_KEYBOARD_LL, LLKeyboardCB, hInst, 0);
  }
 public:
  ~ShiftStatus() {
    if (hHook!=NULL) UnhookWindowsHookEx(hHook);
    Instance = NULL;
  }
  static ShiftStatus *Create(HINSTANCE hInst,
			     DWORD vkCode, HWND hWndA, UINT nMsgA) {
    if (Instance==NULL) {
      Instance = new ShiftStatus(hInst);
    }
    Instance->SetMessage(vkCode, hWndA, nMsgA);
    return Instance;
  }
  void SetMessage(DWORD vkCode, HWND hWndA, UINT nMsgA) {
    kState.bHyper = 0;
    kHyper = vkCode;
    hWnd = hWndA;
    nMsg = nMsgA;
  }
 private:
  static LRESULT CALLBACK LLKeyboardCB(int nCode,WPARAM wParam,LPARAM lParam);
};
#endif
